package Ssm::Db;

=head1 NAME

Ssm::Db - ssm2б ǡ١Ϣ⥸塼

=head2 NOTES

  $Id: Db.pm,v 1.26 2005/01/28 08:01:06 miy Exp $
  Please do 'perldoc -t Ssm::Common' if you get MOJIBAKE.

=head1 SYNOPSIS

  <SSM FUNCTION="Ssm::Db::getvalue" 
     MODE="begin" 
     TABLE="CONTACT" 
     CONDCOLUMN="keycolumn" 
     COND_INPUT_NAME="key">
  <P>keycolumn  ͤ %_keycolumn_% Ǥ</P>
  <SSM MODE="end">

  etc...

  ߥɥ륦SSMѤΥǡ١Ϣ⥸塼ǤбƤΤ ssm2 Ǥ
  Ȥơƥץ졼SSMǻꤷǡ١ΥǡɽΤ˻Ѥޤ

=head1 DESCRIPTION

ؿǤϡssm2ʼ¹ԥեˤѥå main ޤ Ssm::Config ѿѤޤ

=cut

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

use Exporter;
use AutoLoader qw(AUTOLOAD);

use Ssm::Common;
use DBI;
use vars qw($dbh);


@ISA = qw(Exporter AutoLoader);
@EXPORT = qw(
);
$VERSION = do {my @r = (q$Revision: 1.26 $ =~ /\d+/g);sprintf "%d."."%02d" x $#r, @r};


####################################################

=pod

=head2 sub db_disconnect() SSMѴؿ

=over 4

=item ǽ

ͥǤ줿Υǡ١³ϥɥ󥰤

=item 

ʤ

=item 

ʤ

=back

=cut

sub db_disconnect {
	my $sig = shift;
	if ($dbh){
		$dbh->disconnect;
		undef $dbh;
	}
	die "db_disconnect called($sig)";
}


1;
__END__

####################################################

=pod

=head2 sub getlist($$$)

=over 4

=item ǽ

ǡ١λꤷơ֥ʤޤϥӥ塼ˤͤФ
ꥹȤ񤭽Фؿ
쥯饸ܥʤɤν񤭽ФꤷƤ롣

=item 

SSMǶޤ줿ʸ, ꡼֥Ȥؤλ, SSM°ͤäϥåؤλ

=item 

1

=item ǤSSM°

=over 2

=item TABLE

  ǡ򤹤ơ֥̾ޤϥӥ塼̾ɬ°
  ʲΤ褦˥꡼ǻѤ롣
  SLECT [COLUMNS] from [TABLE] (Ｐ)

=item COLUMNS

  ǡ򤹤ơ֥ޤϥӥ塼Υ̾ɬ°
  ʲΤ褦˥꡼ǻѤ롣
  SLECT [COLUMNS] from [TABLE] (Ｐ)

  ޶ڤʣġ꡼ǤΤޤޤʸ󤬻Ѥ롣

=item COND

  ꡼ξ郎ˡWHERE 礫ꤹ롣ɬܡ

=item PARSE_SELECTED

  񤭽ФꥹȤ쥯<OPTION>ˡ饸ܥ󡢥åܥå
  줫ξˡ줿եܤƤǥեȤ
  ֤ȤȿǤ뤫ꡣɬܡ

  ȿǤ硢SSM˶ʸˡ
    ʸꤷƤɬפ롣
    ܺ٤ϡֵǽפιλˡ򻲾ȡ

=over 4

=item  

֤ȿ

=item ꤷʤޤϵ͡0ޤ϶ʸ

ȿǤʤ

=back

=item SELECTNAME

  񤭽ФꥹȤ쥯<OPTION>ˤξǡġ
  줿եܤƤǥեȤ֤Ȥ
  ȿǤPARSE_SELECTED˿ͤꤷˤˡ
  Υ쥯̾ꡣ

  PARSE_SELECTED˿ͤꤷɬ°
  ꤷʤȡPARSE_SELECTED˿ͤꤷƤ
  ֤ȿǤʤ

=item NEWCONN

  ͤꤹСؿƤФ줿󿷤³ƽԤλ³Ǥ롣
  ꤷʤͤꤹСƱ쥻åǺ줿³ФѤƽԤ

=item HIDE_ERROR

ǡ١³顼κݤΥ顼åɽꡣɬܡ

=over 4

=item ꤷʤޤϵ͡0ޤ϶ʸ

HTMLڡɽ

=item "1"

HTMLΥȤȤƽ

=item "2"

ɸ२顼˽

=item 嵭ʳ٤

⤷ʤ

=back

=item RESULTVALUE

  RESULTVALUE°ꤹȡ̽Ϥ̾ __(ꤵ줿ʸ)__ Υѿ˳Ǽ롣
  ̾ϡꤵ줿ʸ˥2Ĥġ
  ꤷʤСɸϤ print ɸưˡ
  ɬܡ

=back


=item 쥯ꥹȤ񤭽Ф֤ȿǤ

  <SELECT NAME="contact_group_id">
  <SSM FUNCTION="getlist" MODE="begin" 
    TABLE="CONTACT_GROUP" 
    COLUMNS="contact_group_id,description" 
    PARSE_SELECTED="1" 
    COND="WHERE mode=1" 
    SELECTNAME="contact_group_id">
  <OPTION VALUE="%_contact_group_id_%" %_selected_%>%_description_%</OPTION>
  <SSM MODE="end">
  </SELECT>

ʸ %_selected_% ϡ֤ȿǤȤˡselectedפȤ
ʸִ֤˻ꤷƤ

PARSE_SELECTEDꤷʤäʸ %_selected_% ꤷƤäƤ⡢
顼ˤϤʤʤ

=item 饸ܥ񤭽Ф֤ȿǤ

  <SSM FUNCTION="getlist" MODE="begin" 
    TABLE="URGENCY" 
    COLUMNS="urgency_id,description" 
    PARSE_SELECTED="1">
  <INPUT TYPE="radio" NAME="urgency_id" VALUE="%_urgency_id_%" %_selected_%> %_description_%
  <SSM MODE="end">

ʸ %_selected_% ϡ֤ȿǤȤˡcheckedפȤ
ʸִ֤˻ꤷƤ

PARSE_SELECTEDꤷʤäʸ %_selected_% ꤷƤäƤ⡢
顼ˤϤʤʤ

=item åܥå񤭽Ф֤ȿǤʤ

  <SSM FUNCTION="getlist" MODE="begin" 
    TABLE="GROUP_MASTER" 
    COLUMNS="group_id,group_name"
    HIDE_ERROR="2"> 
  <input type="checkbox" name="group_id" value="%_group_id_%" %_selected_%>
  [%_group_id_%] %_group_name_% 
  <SSM MODE="end">

ʸ %_selected_% ϡ֤ȿǤȤˡcheckedפȤ
ʸִ֤˻ꤷƤ

PARSE_SELECTEDꤷʤäʸ %_selected_% ꤷƤäƤ⡢
顼ˤϤʤʤ

=back

=cut

sub getlist($$$){
	my ($ssmstr, $queryref, $paramref) = @_;
	my ($sql, $i, $j, $ary_ref, $temp, @columns, $res,
		$selectstr, @temp, $token, $inselect, 
		$selectname, $found, $posted, $parsedlist, $inputname, @vals, @cond, $parser);

	$ssmstr =~ /^\s*$/ and return 1;

	$paramref->{'columns'} and @columns = split(/,\s*/, $paramref->{'columns'})
		or do {
			unless ($paramref->{'hide_error'}){
				&Ssm::Common::errormsg('ɬפʥѥ᡼ꤵƤޤ');
			} else {
				if ($paramref->{'hide_error'} == 1){
					print '<!--ERROR: Attribute columns required.-->';
				} elsif ($paramref->{'hide_error'} == 2) {
					warn 'ERROR: Attribute columns required';
				}
			}
			return 1;
		};

	if (defined $paramref->{'resultvalue'} && $paramref->{'resultvalue'} =~ /^\w+$/){
		$res = "__$paramref->{'resultvalue'}__";
	}

	$sql = "SELECT ".$paramref->{'columns'}." ";
	$sql .= "FROM ".$paramref->{'table'}." " if $paramref->{'table'};

	#åڤ줿ȤDBǽ
	local (%main::SIG);
	$SIG{'TERM'} = $SIG{'CHLD'} = $SIG{'KILL'} = $SIG{'INT'} = \&db_disconnect;
	$temp = &get_dbh($paramref->{newconn});
	$temp and $dbh = $$temp or undef $dbh;

	($dbh) or do {
		unless ($paramref->{'hide_error'}){
			&Ssm::Common::errormsg('ǥ顼ޤ');
		} else {
			if ($paramref->{'hide_error'} == 1){
				print '<!--ERROR: db handler was not created.-->';
			} elsif ($paramref->{'hide_error'} == 2) {
				warn 'ERROR: db handler was not created.';
			}
		}
		return 1;
	};

	if ($paramref->{'cond'}) {
		$cond[0] = $paramref->{'cond'};
	}
	if ($paramref->{'condcolumn'}) {
		$inputname = ($paramref->{'cond_input_name'})?$paramref->{'cond_input_name'}:$paramref->{'condcolumn'};
		if (defined($$queryref->Vars->{$inputname}) and $$queryref->Vars->{$inputname} ne ''){
			@vals = split(/\0/,$$queryref->Vars->{$inputname});
			for ($i=0; $i<=$#vals; $i++){
				$cond[1] .= ($i==0)?"":"OR ";
				$cond[1] .= $paramref->{'condcolumn'}." = ".$dbh->quote($vals[$i])." ";
			}
		}
	}
	
	if ($cond[0] && $cond[1]) {
		$sql .= "$cond[0] and ( $cond[1] ) ";
	} elsif (!$cond[0] && $cond[1]) {
		$sql .= "WHERE $cond[1]";
	} elsif ($cond[0] && !$cond[1]) {
		$sql .= $cond[0];
	}

	eval {
		if ($DBI::VERSION >= 1.20 ){
			$ary_ref = $dbh->selectall_arrayref($sql, {Columns=>{}});
		} else {
			$ary_ref = $dbh->selectall_hashref($sql);
		}
	}
		or do {
			$dbh->disconnect;
			unless ($paramref->{'hide_error'}){
				&Ssm::Common::errormsg('ǥ顼ޤ');
			} else {
				if ($paramref->{'hide_error'} == 1){
					print "<!--ERROR: select query failed. $sql-->";
				} elsif ($paramref->{'hide_error'} == 2) {
					warn "ERROR: dbh->selectall_hashref failed. SQL = $sql";
					warn $dbh->errstr if $dbh->err;
				}
			}
			return 1;
		};
	$paramref->{newconn} and $dbh->disconnect and undef $dbh;

	return 1 unless ((ref $ary_ref) && (scalar @$ary_ref));

	foreach $i (@$ary_ref){
		$temp = $ssmstr;
		for ($j=0; $j <= $#columns; $j++){
			$temp =~ s/%_$columns[$j]_%/&Ssm::Common::text2html($i->{$columns[$j]})/eg;
		}
		$parsedlist .= $temp;
	}

	if ($paramref->{'parse_selected'}){
		$parser = new HTML::TokeParser( \$parsedlist ) or return 0;
		while ($token = $parser->get_token()){
			@temp = @$token;
			if ($token->[0] eq "S" && $token->[1] eq "option" && $paramref->{'selectname'}){
				if ($token->[2]->{'%_selected_%'}){
					$found = 0;
					if (defined ($$queryref->Vars->{$paramref->{'selectname'}}) and $$queryref->Vars->{$paramref->{'selectname'}} ne ''){
						IFPOSTED:foreach $posted (split(/\0/,$$queryref->Vars->{$paramref->{'selectname'}})){
							$temp = &Ssm::Common::text2html($posted);
							if ($token->[2]->{'value'} eq $temp){
								$token->[$#temp] =~ s#%_selected_%#selected#i;
								$found = 1;
								last IFPOSTED;
							}
						}
					}
					$token->[$#temp] =~ s#%_selected_%##i unless $found;
				}
				if ($res){
					$$queryref->Vars->{$res} .= $token->[$#temp];
				} else {
					print $token->[$#temp];
				}
			}
			elsif ($token->[0] eq "S" && $token->[1] eq "input" && $token->[2]->{'type'} eq "radio"){
				if ($token->[2]->{'%_selected_%'}){
					if (defined($$queryref->Vars->{$token->[2]->{'name'}})){
						$temp = &Ssm::Common::text2html($$queryref->Vars->{$token->[2]->{'name'}});
						if( $token->[2]->{'value'} eq $temp ){
							$token->[$#temp] =~ s#%_selected_%#checked#i;
						} else {
							$token->[$#temp] =~ s#%_selected_%##i;
						}
					}
				}
				if ($res){
					$$queryref->Vars->{$res} .= $token->[$#temp];
				} else {
					print $token->[$#temp];
				}
			}
			elsif ($token->[0] eq "S" && $token->[1] eq "input" && $token->[2]->{'type'} eq "checkbox"){
				if ($token->[2]->{'%_selected_%'}){
					$found = 0;
					if (defined($$queryref->Vars->{$token->[2]->{'name'}}) and $$queryref->Vars->{$token->[2]->{'name'}} ne ''){
						IFPOSTED:foreach $posted (split(/\0/,$$queryref->Vars->{$token->[2]->{'name'}})){
							$temp = &Ssm::Common::text2html($posted);
							if ($token->[2]->{'value'} eq $temp){
								$token->[$#temp] =~ s#%_selected_%#checked#i;
								$found = 1;
								last IFPOSTED;
							}
						}
					}
					$token->[$#temp] =~ s#%_selected_%##i unless $found;
				}
				if ($res){
					$$queryref->Vars->{$res} .= $token->[$#temp];
				} else {
					print $token->[$#temp];
				}
			}
			elsif ($token->[0] eq "T"){
				if ($res){
					$$queryref->Vars->{$res} .= $token->[1];
				} else {
					print $token->[1];
				}
			} else {
				if ($res){
					$$queryref->Vars->{$res} .= $token->[$#temp];
				} else {
					print $token->[$#temp];
				}
			}
		}
	} else {
		$parsedlist =~ s#%_selected_%##igs;
		if ($res){
			$$queryref->Vars->{$res} .= $parsedlist;
		} else {
			print $parsedlist;
		}
	}
	return 1;
}


####################################################

=pod

=head2 sub getvalue($$$)

=over 4

=item ǽ

ǡ١λꤷơ֥ʤޤϥӥ塼ˤͤФ
ꥹȤ񤭽Фؿ

Ф͡ʥˤϡSSMǶʸˡ'%_'  '_%' Ƕǻꤹ롣

'%_'  '_%' Ƕޤ줿ʸƱΥ̾ʤ硢顼Ȥʤ롣

ꤵ줿ʣΥ줿硢٤ƤΥͤ򷫤֤񤭽Ф

=item 

SSMǶޤ줿ʸ, ꡼֥Ȥؤλ, SSM°ͤäϥåؤλ

=item 

1

=item ǤSSM°

=over 2

=item TABLE

  ǡ򤹤ơ֥̾ޤϥӥ塼̾ɬ°
  ʲΤ褦˥꡼ǻѤ롣
  SLECT (̾) from [TABLE] (Ｐ)

=item COND

  ꡼ξ郎ˡWHERE 礫ꤹ롣ɬܡ

  CONDCOLUMN ꤷƤ硢CONDCOLUMN ˤäƻꤵ
  ΤȤ AND Ȥʤ롣

=item CONDCOLUMN

  CONDʳˡ줿ͤＰꤷˡ
  ˤ륫̾ꤹ롣ɬܡ
  ʣԲġ

  COND_INPUT_NAME ꤵƤϡλꤵ줿̾NAMEˤ
  ͤꤵƤʤСCONDCOLUMN Ʊ̾ͤ
  ȤƻѤ롣
  ͤʣϡOR Ȥʤ롣

  COND ꤷƤ硢COND ξȤ AND Ȥʤ롣

=item COND_INPUT_NAME

  CONDCOLUMN ꤷˡCONDCOLUMN ʳ̾ͤȤ
  Ѥˤ̾NAMEˤꤹ롣ɬܡ

=item NEWCONN

  ͤꤹСؿƤФ줿󿷤³ƽԤλ³Ǥ롣
  ꤷʤͤꤹСƱ쥻åǺ줿³ФѤƽԤ

=item HIDE_ERROR

ǡ١³顼κݤΥ顼åɽꡣɬܡ

=over 4

=item ꤷʤޤϵ͡0ޤ϶ʸ

HTMLڡɽ

=item "1"

HTMLΥȤȤƽ

=item "2"

ɸ२顼˽

=item 嵭ʳ٤

⤷ʤ

=back

=item RESULTVALUE

  RESULTVALUE°ꤹȡ̽Ϥ̾ __(ꤵ줿ʸ)__ Υѿ˳Ǽ롣
  ̾ϡꤵ줿ʸ˥2Ĥġ
  ꤷʤСɸϤ print ɸưˡ
  ɬܡ

=back


=item 

  <TABLE>
  <SSM FUNCTION="getvalue" MODE="begin" 
    TABLE="userdata" 
    COND="mode=1" 
    CONDCOLUMN="login_id" 
    COND_INPUT_NAME="target_id" 
    HIDE_ERROR="2">
  <TR>
  <TD>%_login_id_%</TD>
  <TD>%_name_%</TD>
  <TD>%_company_%</TD>
  <TD>%_address_%</TD>
  </TR>
  <SSM MODE="end">
  </TABLE>

=item SQLʸؤŸ

嵭ֻפΤ褦˻ꤷ硢ʲSQLʸ¹Ԥ롣
target_id Ȥơ1  2 ƤȤ롣

  SELECT login_id, name, company, address 
  FROM userdata 
  WHERE mode=1 AND
  (login_id = 1 OR login_id = 2)


=back

=cut


sub getvalue($$$){
	my ($ssmstr, $queryref, $paramref) = @_;
	my ($sql, $i, $j, $ary_ref, $temp, $inputname, @vals, @fields, @cond, $res);

	@fields = ($ssmstr =~ m/%_(\w+)_%/gs) and $paramref->{'table'}
		or do {
			unless ($paramref->{'hide_error'}){
				&Ssm::Common::errormsg('ɬפʥѥ᡼ꤵƤޤ');
			} else {
				if ($paramref->{'hide_error'} == 1){
					print '<!--ERROR: column name must be included in ssmstr, attribute table is mandatory.-->';
				} elsif ($paramref->{'hide_error'} == 2) {
					warn 'ERROR: column name must be included in ssmstr, attribute table is mandatory.';
				}
			}
			return 1;
		};

	if (defined $paramref->{'resultvalue'} && $paramref->{'resultvalue'} =~ /^\w+$/){
		$res = "__$paramref->{'resultvalue'}__";
	}

	$sql = "SELECT ".join(",", @fields)." ";
	$sql .= "FROM ".$paramref->{'table'}." ";

	#åڤ줿ȤDBǽ
	local (%main::SIG);
	$SIG{'TERM'} = $SIG{'CHLD'} = $SIG{'KILL'} = $SIG{'INT'} = \&db_disconnect;
	$temp = &get_dbh($paramref->{newconn});
	$temp and $dbh = $$temp or undef $dbh;
	($dbh) or do {
		unless ($paramref->{'hide_error'}){
			&Ssm::Common::errormsg('ǥ顼ޤ');
		} else {
			if ($paramref->{'hide_error'} == 1){
				print '<!--ERROR: db handler was not created.-->';
			} elsif ($paramref->{'hide_error'} == 2) {
				warn 'ERROR: db handler was not created.';
			}
		}
		return 1;
	};

	if ($paramref->{'cond'}) {
		$cond[0] = $paramref->{'cond'};
	}
	if ($paramref->{'condcolumn'}) {
		$inputname = ($paramref->{'cond_input_name'})?$paramref->{'cond_input_name'}:$paramref->{'condcolumn'};
		if (defined($$queryref->Vars->{$inputname}) and $$queryref->Vars->{$inputname} ne ''){
			@vals = split(/\0/,$$queryref->Vars->{$inputname});
			for ($i=0; $i<=$#vals; $i++){
				$cond[1] .= ($i==0)?"":"OR ";
				$cond[1] .= $paramref->{'condcolumn'}." = ".$dbh->quote($vals[$i])." ";
			}
		}
	}
	
	if ($cond[0] && $cond[1]) {
		$sql .= "$cond[0] and ( $cond[1] ) ";
	} elsif (!$cond[0] && $cond[1]) {
		$sql .= "WHERE $cond[1]";
	} elsif ($cond[0] && !$cond[1]) {
		$sql .= $cond[0];
	}

	eval {
		if ($DBI::VERSION >= 1.20 ){
			$ary_ref = $dbh->selectall_arrayref($sql, {Columns=>{}});
		} else {
			$ary_ref = $dbh->selectall_hashref($sql);
		}
	}
		or do {
			$dbh->disconnect;
			unless ($paramref->{'hide_error'}){
				&Ssm::Common::errormsg('ǥ顼ޤ');
			} else {
				if ($paramref->{'hide_error'} == 1){
					print "<!--ERROR: select query failed. $sql-->";
				} elsif ($paramref->{'hide_error'} == 2) {
					warn "ERROR: dbh->selectall_hashref failed. SQL = $sql";
					warn $dbh->errstr if $dbh->err;
				}
			}
			return 1;
		};

	$paramref->{newconn} and $dbh->disconnect and undef $dbh;

	return 1 unless ((ref $ary_ref) && (scalar @$ary_ref));

	foreach $i (@$ary_ref){
		$temp = $ssmstr;
		for ($j=0; $j <= $#fields; $j++){
			if ($i->{$fields[$j]}){
				$temp =~ s/%_$fields[$j]_%/&Ssm::Common::text2html($i->{$fields[$j]})/eg;
			} else {
				$temp =~ s/%_$fields[$j]_%//g;
			}
		}
		if ($res){
			$$queryref->Vars->{$res} .= $temp;
		} else {
			print $temp;
		}
	}
	return 1;
}


####################################################

=pod

=head2 sub prepare_table_value($$$)

=over 4

=item ǽ

ǡ١λꤷơ֥ʤޤϥӥ塼ˤͤФ
ͤ򥯥꡼֥롣

COLUMNSǻꤷ̾ꤷơ֥ʤޤϥӥ塼˾̵硢顼Ȥʤ롣

ꤵ줿ʣΥ줿硢
ǽΥͤΤߤ򥯥꡼֥롣

̾ϡ1Τ߸뤳Ȥꤵꤷ
ꤷͤڡɽŪǻѤ뤳ȤꤷƤ롣

ʣSSMꤹ뤳Ȥˤꡢ
1ĤΥڡɽͤʣΥơ֥ʤޤϥӥ塼ˤ
뤳ȤǤ롣

1ĤΥڡɽͤ1ĤΥơ֥ʤޤϥӥ塼ˤϡ
getvalue()˻Ѥ뤳ȤǤ롣

=item 

SSMǶޤ줿ʸ, ꡼֥Ȥؤλ, SSM°ͤäϥåؤλ

=item 

1 + (ꤵ줿Ǹ줿ǡ)

=item ǤSSM°

=over 2

=item TABLE

  ǡ򤹤ơ֥̾ޤϥӥ塼̾ɬ°
  ʲΤ褦˥꡼ǻѤ롣
  SLECT [COLUMNS] from [TABLE] (Ｐ)

=item COLUMNS

  ǡ򤹤ơ֥ޤϥӥ塼Υ̾ɬܡ
  ʲΤ褦˥꡼ǻѤ롣
  SLECT [COLUMNS] from [TABLE] (Ｐ)

  ޶ڤʣġ꡼ǤΤޤޤʸ󤬻Ѥ롣

  ꤷʤ硢٤ƤΥ*ˤоݤȤʤ롣


=item COND

  ꡼ξ郎ˡWHERE 礫ꤹ롣ɬܡ

  CONDCOLUMN ꤷƤ硢CONDCOLUMN ˤäƻꤵ
  ΤȤ AND Ȥʤ롣

=item CONDCOLUMN

  CONDʳˡ줿ͤＰꤷˡ
  ˤ륫̾ꤹ롣ɬܡ
  ʣԲġ

  COND_INPUT_NAME ꤵƤϡλꤵ줿̾NAMEˤ
  ͤꤵƤʤСCONDCOLUMN Ʊ̾ͤ
  ȤƻѤ롣
  ͤʣϡOR Ȥʤ롣

  COND ꤷƤ硢COND ξȤ AND Ȥʤ롣

=item COND_INPUT_NAME

  CONDCOLUMN ꤷˡCONDCOLUMN ʳ̾ͤȤ
  Ѥˤ̾NAMEˤꤹ롣ɬܡ

=item NEWCONN

  ͤꤹСؿƤФ줿󿷤³ƽԤλ³Ǥ롣
  ꤷʤͤꤹСƱ쥻åǺ줿³ФѤƽԤ

=item HIDE_ERROR

ǡ١³顼κݤΥ顼åɽꡣɬܡ

=over 4

=item ꤷʤޤϵ͡0ޤ϶ʸ

HTMLڡɽ

=item "1"

HTMLΥȤȤƽ

=item "2"

ɸ२顼˽

=item 嵭ʳ٤

⤷ʤ

=back

=item FORMAT

Ϥηꤹ롣ɬܡ

=over 4

=item html

ʸHTMLüʸΥƥƥؤѴԤ

=item 嵭ʳ̵

ʸѴԤʤ

=back

=back


=item 

  <SSM FUNCTION="prepare_table_value" MODE="begin" 
    TABLE="PERSONAL_DATA" 
    COND="WHERE mode = 0" 
    CONDCOLUMN="login_id"
    COLUMNS="name">
  <SSM MODE="end">
  <SSM FUNCTION="prepare_table_value" MODE="begin" 
    TABLE="LOGIN_MASTER" 
    COND="WHERE mode = 0" 
    CONDCOLUMN="login_id" 
    COLUMNS="login_name">
  <SSM MODE="end">
  <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
  <HTML>
  ...ά
  <BODY>
  <SSM ACTION="once" FUNCTION="Ssm::Common::printvalue" MODE="begin">
  <FORM ACTION="next.cgi" METHOD="post">
  <input type="hidden" name="login_id" value="%_login_id_%">
  <input type="hidden" name="login_name" value="%_login_name_%">
  <input type="hidden" name="name" value="%_name_%">
  </FORM>
  <SSM MODE="end">

=back

=cut

sub prepare_table_value($$$){
	my ($ssmstr, $queryref, $paramref) = @_;
	my ($sql, $i, $j, $ary_ref, $temp, $inputname, @vals, @cond);

	$paramref->{'table'}
		or do {
			unless ($paramref->{'hide_error'}){
				&Ssm::Common::errormsg('ɬפʥѥ᡼ꤵƤޤ');
			} else {
				if ($paramref->{'hide_error'} == 1){
					print '<!--ERROR: attribute table is mandatory.-->';
				} elsif ($paramref->{'hide_error'} == 2) {
					warn 'ERROR: attribute table is mandatory.';
				}
			}
			return 1;
		};

	$sql = "SELECT ";
	$sql .= $paramref->{'columns'}?$paramref->{'columns'}:" * ";
	$sql .= " FROM ".$paramref->{'table'}." ";

	#åڤ줿ȤDBǽ
	local (%main::SIG);
	$SIG{'TERM'} = $SIG{'CHLD'} = $SIG{'KILL'} = $SIG{'INT'} = \&db_disconnect;
	$temp = &get_dbh($paramref->{newconn});
	$temp and $dbh = $$temp or undef $dbh;
	($dbh) or do {
		unless ($paramref->{'hide_error'}){
			&Ssm::Common::errormsg('ǥ顼ޤ');
		} else {
			if ($paramref->{'hide_error'} == 1){
				print '<!--ERROR: db handler was not created.-->';
			} elsif ($paramref->{'hide_error'} == 2) {
				warn "ERROR: db handler was not created.";
			}
		}
		return 1;
	};

	if ($paramref->{'cond'}) {
		$cond[0] = $paramref->{'cond'};
	}
	if ($paramref->{'condcolumn'}) {
		$inputname = ($paramref->{'cond_input_name'})?$paramref->{'cond_input_name'}:$paramref->{'condcolumn'};
		if (defined($$queryref->Vars->{$inputname}) && $$queryref->Vars->{$inputname} ne ''){
			@vals = split(/\0/,$$queryref->Vars->{$inputname});
			for ($i=0; $i<=$#vals; $i++){
				$cond[1] .= ($i==0)?"":"OR ";
				$cond[1] .= $paramref->{'condcolumn'}." = ".$dbh->quote($vals[$i])." ";
			}
		}
	}
	
	if ($cond[0] && $cond[1]) {
		$sql .= $cond[0]." and ( ".$cond[1]." ) ";
	} elsif (!$cond[0] && $cond[1]) {
		$sql .= "WHERE ".$cond[1];
	} elsif ($cond[0] && !$cond[1]) {
		$sql .= $cond[0];
	}

	eval {
		if ($DBI::VERSION >= 1.20 ){
			$ary_ref = $dbh->selectall_arrayref($sql, {Columns=>{}});
		} else {
			$ary_ref = $dbh->selectall_hashref($sql);
		}
	}
		or do {
			$dbh->disconnect;
			unless ($paramref->{'hide_error'}){
				&Ssm::Common::errormsg('ǥ顼ޤ');
			} else {
				if ($paramref->{'hide_error'} == 1){
					print "<!--ERROR: select query failed. $sql-->";
				} elsif ($paramref->{'hide_error'} == 2) {
					warn "ERROR: dbh->selectall_hashref failed. SQL = $sql";
					warn $dbh->errstr if $dbh->err;
				}
			}
			return 1;
		};

	$paramref->{newconn} and $dbh->disconnect and undef $dbh;
	foreach $i (@$ary_ref){
		foreach $temp (keys %$i){
			if (defined($i->{$temp}) && $i->{$temp} ne ''){
				if ($paramref->{'format'} && $paramref->{'format'} =~ /^html$/i) {
					$$queryref->Vars->{$temp} = &Ssm::Common::text2html($i->{$temp});
				} else {
					$$queryref->Vars->{$temp} = $i->{$temp};
				}
			}
		}
		last; #ʣǤ⡢1ǽλ
	}

	$temp = 0;
	scalar @$ary_ref and $temp = scalar(@$ary_ref);
	return 1+$temp;
}

####################################################

=pod

=head2 sub get_dbh()

=over 4

=item ǽ

DBI⥸塼Ѥǡ١³ϥɥλȤ֤
¹Υ桼ؿޤޤѥåǴ¸Υϥɥ餬С³ϹԤ鷺¸ΥϥɥλȤ֤

=item 

 ʾάǽͤͿȡ˿³롣

=item 

DBIǡ١ϥɥλȡ
³˼Ԥ硢 undef ֤

=back

=cut

sub get_dbh{
	my $newconn = shift;
	my ($mydbh);
	unless ($newconn){
		$mydbh = $dbh || eval("\$".&Ssm::Common::getpackagename($main::funcscr)."::dbh");
	}
	$mydbh and $mydbh->{Active}
		or do {
			eval "\$mydbh = DBI->connect($Ssm::Config::connstr)";
		};
	return $mydbh?\$mydbh:undef;
}

####################################################

=pod

=head2 sub gen_unique_key($number)

=over 4

=item ǽ

ǻꤵ줿ʡХȿˤΥʸ֤
HTMLΥƥƥѴסӡSQLʸǤΥפפϰϤʸΤߤѡ

 530 ϰϤ̵硢15ʸ֤

=item 

 ʾάǽϰ = 530ǥե = 15

=item 

ʸ

=back

=cut

sub gen_unique_key($){
	my $length = shift;
	my ($tempval, $key);
	($length and $length =~ m/^\d+$/ and $length >= 5 and $length <= 30 ) or $length = 15;
	srand(&gen_seed());
	while ($length){
		$tempval = int(rand(87)) + 40;
		#ʸ֤\  w <  S >  M
		($tempval == 92 and $tempval = 119)
			or ($tempval == 60 and $tempval = 83)
			or ($tempval == 62 and $tempval = 77);
		$key .= sprintf("%c", $tempval);
		$length--;
	}
	return $key;
}

#ץIDˤꡢ̡Υͤȯˡ
sub gen_seed{
	srand(time|$$);
	if ($$<20000){
		return ((time >> (int(rand(3))+1))|($$**2 >> (int(rand(3))+1)));
	} elsif ($$<50000){
		return ((time >> (int(rand(3))+1))|$$);
	} else {
		return ((time >> (int(rand(3))+1))|(($$)/(int(rand(3))+3))**2);
	}
}

####################################################

=pod

=head2 sub postgres_escape($)

=over 4

=item ǽ

Υ󥰥륯ȡ\ޡʥХååˤ򥨥פ롣
פʸ֤

ɽθʸʤɡDBI ⥸塼󶡤 quote ؿȤʤλѤꡣ

=item 

ʸ

=item 

ʸ

=back

=cut

sub postgres_escape($) {
	my $string = shift;
	if ($string){
		$string =~ s/'/''/g;
		$string =~ s/\\/\\\\/g;
	}
	return $string;
}



=head1 AUTHOR

  Miyabiko INOUE <miy@web-ware.org>
  ХθϢ mailto:miy@web-ware.org ޤǤꤤޤ

=head1 COPYRIGHT

  Copyright (c) Miyabiko INOUE <miy@web-ware.org>.
  All rights reserved.

  Υ⥸塼̵ǤѤޤ
  ѡۤʤɤλѵ˴ؤƤϡPerl  Artistic License ŬѤޤ

  This program is free software; you can redistribute it
  and/or modify it under Perl Artistic License.

=head1 NOTES

  Further information: http://www.web-ware.org/

=head1 SEE ALSO

perl(1).

=cut

1;
